
%%                                      COLORMAP AND COLORBAR SETTINGS 2.1

%                                                Fabio Crameri, 07.10.2016

%% INPUT
% SWITCH.ColormapAll        % {'default'  'noflip'};
% PLOT.multipleColormap     % logical
% PLOT.hax                  % axis handle
% PLOT.cb                   % colorbar handle

function [SWITCH] = f_colormap(SWITCH,PLOT)

%% DEFAULTS
if ~isfield(SWITCH,'ColormapAll');          SWITCH.ColormapAll      	= {'default'  'noflip'}; end
if ~isfield(SWITCH,'cbarLimitIndicTop');    SWITCH.cbarLimitIndicTop    = false; end
if ~isfield(SWITCH,'cbarLimitIndicBot');    SWITCH.cbarLimitIndicBot    = false; end
if ~isfield(PLOT,'multipleColormap');    	PLOT.multipleColormap   	= true; end
if ~isfield(PLOT,'cbFactorX');              PLOT.cbFactorX           	= 0.5; end
if ~isfield(PLOT,'cbFactorY');              PLOT.cbFactorY           	= 1.0; end
if ~isfield(PLOT,'loopPlot');               PLOT.loopPlot               = 1; end

%% CHECK FOR SELF-MADE COLORMAP
if size(SWITCH.ColormapAll{1,1},1)==1 && exist([SWITCH.ColormapAll{1,1},'.mat'],'file')==2   %if not numeric value
    load([SWITCH.ColormapAll{1,1},'.mat']); SWITCH.ColormapAll{1,1}=eval( sprintf(SWITCH.ColormapAll{1,1}) ); %load colormap
end

%% ADD A COLORBAR EXCEEDING INDICATION COLOUR
% AT TOP:
if size(SWITCH.cbarLimitIndicTop,2)==1 %apply for all subplots if only one value
    testIndex1 = 1;
else %apply for specific subplots
    testIndex1 = PLOT.loopPlot;
end
if SWITCH.cbarLimitIndicTop(1,testIndex1) && size(SWITCH.ColormapAll{1,1},2)==3 %plus if its a numeric colormap
    SWITCH.ColormapAll{1,1} = [SWITCH.ColormapAll{1,1}(:,:); SWITCH.cbarLimitColorTop; SWITCH.cbarLimitColorTop]; %add to the top
end
% AT BOTTOM:
if size(SWITCH.cbarLimitIndicBot,2)==1 %apply for all subplots if only one value
    testIndex2 = 1;
else %apply for specific subplots
    testIndex2 = PLOT.loopPlot;
end
if SWITCH.cbarLimitIndicBot(1,testIndex2) && size(SWITCH.ColormapAll{1,1},2)==3 %plus if its a numeric colormap
    SWITCH.ColormapAll{1,1} = [SWITCH.cbarLimitColorBot; SWITCH.cbarLimitColorBot; SWITCH.ColormapAll{1,1}(:,:)]; %add to the bottom
end
if (SWITCH.cbarLimitIndicTop(1,testIndex1) || SWITCH.cbarLimitIndicBot(1,testIndex2)) && ~size(SWITCH.ColormapAll{1,1},2)==3
    disp('...could not apply lower colorbar limit indication!')
end

%% APPLY SPECIFIC COLORMAP
if PLOT.multipleColormap %for multiple axis per figure
    if strcmp(SWITCH.ColormapAll{1,2},'flip')
        colormap(PLOT.hax,flipud(SWITCH.ColormapAll{1,1}));
    elseif strcmp(SWITCH.ColormapAll{1,2},'noflip')
        colormap(PLOT.hax,SWITCH.ColormapAll{1,1});
    else
        error('Unknown Colormap option: Flip or no flip?')
    end
    
else %for whole figure
    if strcmp(SWITCH.ColormapAll{1,2},'flip')
        colormap(SWITCH.ColormapAll{1,1});
        colormap(flipud(colormap));
    elseif strcmp(SWITCH.ColormapAll{1,2},'noflip')
        colormap(SWITCH.ColormapAll{1,1});
    else
        error('Unknown Colormap option: Flip or no flip?')
    end
end

