
%%                                              FIGURE SIZE & POSITION 1.2

%                                                Fabio Crameri, 30.08.2016

% Input:
% FPOS.subplotLayout    = [2 3];
% FPOS.setAxisLimit     = SWITCH.setAxisLimit;  %switch predefined axis limit
% FPOS.axisLimit        = SWITCH.axisLimit;     %manual axis limits
% [FPOS] = f_figurePosition(FPOS,GRID,PLOT);

% Output:
% FPOS

function [FPOS] = f_figurePosition(FPOS,GRID,PLOT)

%% get current figure position
figPosCurr = get(gcf,'Position');
FPOS.size = figPosCurr(1,3:4);

%% set figure position
FPOS.x = 47;
FPOS.y = 1;

%% set figure width and height
%'standard'
if FPOS.subplotLayout(1,1)==1 && FPOS.subplotLayout(1,2)==1; FPOS.size = [600 300];           	%[1 1]
elseif FPOS.subplotLayout(1,1)==1 && FPOS.subplotLayout(1,2)==2; FPOS.size = [800 250];        	%[1 2]
elseif FPOS.subplotLayout(1,1)==1 && FPOS.subplotLayout(1,2)==3; FPOS.size = [1200 200];       	%[1 3]
elseif FPOS.subplotLayout(1,1)==1 && FPOS.subplotLayout(1,2)==4; FPOS.size = [1400 200];      	%[1 4] test
elseif FPOS.subplotLayout(1,1)==1 && FPOS.subplotLayout(1,2)>4; FPOS.size = [1400 200];       	%[1 big]
    
elseif FPOS.subplotLayout(1,1)==2 && FPOS.subplotLayout(1,2)==1; FPOS.size = [630 600];       	%[2 1]
elseif FPOS.subplotLayout(1,1)==2 && FPOS.subplotLayout(1,2)==2; FPOS.size = [930 479];        	%[2 2]
elseif FPOS.subplotLayout(1,1)==2 && FPOS.subplotLayout(1,2)==3; FPOS.size = [1435 479];      	%[2 3]
elseif FPOS.subplotLayout(1,1)==2 && FPOS.subplotLayout(1,2)==4; FPOS.size = [1435 400];      	%[2 4] test
elseif FPOS.subplotLayout(1,1)==2 && FPOS.subplotLayout(1,2)>4; FPOS.size = [1700 300];       	%[2 big] test
    
elseif FPOS.subplotLayout(1,1)==3 && FPOS.subplotLayout(1,2)==1; FPOS.size = [530 800];       	%[3 1]
elseif FPOS.subplotLayout(1,1)==3 && FPOS.subplotLayout(1,2)==2; FPOS.size = [840 600];      	%[3 2]
elseif FPOS.subplotLayout(1,1)==3 && FPOS.subplotLayout(1,2)==3; FPOS.size = [1050 500];      	%[3 3]
elseif FPOS.subplotLayout(1,1)==3 && FPOS.subplotLayout(1,2)==4; FPOS.size = [1400 450];     	%[3 4] ok
elseif FPOS.subplotLayout(1,1)==3 && FPOS.subplotLayout(1,2)==5; FPOS.size = [1700 450];     	%[3 5] ok
elseif FPOS.subplotLayout(1,1)==3 && FPOS.subplotLayout(1,2)>5; FPOS.size = [1700 400];       	%[3 big] ok
    
elseif FPOS.subplotLayout(1,1)==4 && FPOS.subplotLayout(1,2)==1; FPOS.size = [350 700];      	%[4 1] ok
elseif FPOS.subplotLayout(1,1)==4 && FPOS.subplotLayout(1,2)==2; FPOS.size = [840 700];       	%[4 2] ok
elseif FPOS.subplotLayout(1,1)==4 && FPOS.subplotLayout(1,2)==3; FPOS.size = [1050 650];      	%[4 3]
elseif FPOS.subplotLayout(1,1)==4 && FPOS.subplotLayout(1,2)==4; FPOS.size = [1253 700];     	%[4 4]
elseif FPOS.subplotLayout(1,1)==4 && FPOS.subplotLayout(1,2)>4; FPOS.size = [1400 700];      	%[4 big] test
    
elseif FPOS.subplotLayout(1,1)==5 && FPOS.subplotLayout(1,2)==1; FPOS.size = [420 820];      	%[5 1] ok
elseif FPOS.subplotLayout(1,1)==5 && FPOS.subplotLayout(1,2)==2; FPOS.size = [840 820];      	%[5 2] ok
elseif FPOS.subplotLayout(1,1)==5 && FPOS.subplotLayout(1,2)==3; FPOS.size = [1150 820];       	%[5 3] ok
elseif FPOS.subplotLayout(1,1)==5 && FPOS.subplotLayout(1,2)==4; FPOS.size = [1450 820];       	%[5 4] ok

    
elseif FPOS.subplotLayout(1,1)>4 && FPOS.subplotLayout(1,2)>4; FPOS.size = [1400 1000];      	%[big big] ok
else
    disp(['...subplot layout [',num2str(FPOS.subplotLayout),'] is not available'])
    disp('   -->> using current figure size.')
end

%% account for addition of zoom plots
if PLOT.zoom
    FPOS.size(1,1)      = FPOS.size(1,1)*11/10;         %make plots wider
end

%% account for plot nx:nz aspect ratio & 3-D plots
%get subplot aspect ratio
if isfield(FPOS,'setAxisLimit') && FPOS.setAxisLimit
    spAspectRatio       = (FPOS.axisLimit(1,2)-FPOS.axisLimit(1,1))/(FPOS.axisLimit(1,4)-FPOS.axisLimit(1,3));
else
    if strcmp(GRID.Dim,'2-D')
        spAspectRatio   = GRID.nx/GRID.nz;
    elseif strcmp(GRID.Dim,'3-D')
        spAspectRatio   = GRID.ny/GRID.nz;
    end
end
%apply to appropriate figure size
if strcmp(GRID.Dim,'2-D')
    if strcmp(GRID.Type,'Cartesian')
        if spAspectRatio==1 %for 1:1 aspect ratio
            FPOS.size(1,1) = FPOS.size(1,1) *0.75;      %shorten width
        elseif spAspectRatio==4 %for 4:1 aspect ratio
            FPOS.size(1,1) = FPOS.size(1,1) *1.5;       %extend width
            FPOS.size = FPOS.size *0.75;                %decrease overall size
        elseif spAspectRatio==8 %for 8:1 aspect ratio
            FPOS.size(1,1) = FPOS.size(1,1) *2.3;       %extend width
            FPOS.size = FPOS.size *0.7;                 %decrease overall size
        end
    elseif strcmp(GRID.Type,'cylindrical')
        %subplots are in fact nearly 1:1 aspect
        FPOS.size(1,2) = FPOS.size(1,2) *1.5;     %extend height
        FPOS.size = FPOS.size *1.0;            %decrease overall size
    else
        error('no geometry found! check here.')
    end
    
elseif strcmp(GRID.Dim,'3-D')
    if strcmp(GRID.Type,'Cartesian')
        FPOS.size(1,2) = FPOS.size(1,2) *1.1;     %larger overall height
        FPOS.size = FPOS.size *1.5;                 %increase overall size
        
        if spAspectRatio==1 %for 1:1 aspect ratio
            FPOS.size(1,1) = FPOS.size(1,1) *0.75;     %shorten width
        elseif spAspectRatio==4 %for 4:1 aspect ratio
            FPOS.size(1,1) = FPOS.size(1,1) *1.1;     %extend width
            FPOS.size = FPOS.size *0.75;            %decrease overall size
        elseif spAspectRatio==8 %for 8:1 aspect ratio
            FPOS.size(1,1) = FPOS.size(1,1) *1.45;     %extend width
            FPOS.size = FPOS.size *0.7;           	%decrease overall size
        end
    elseif strcmp(GRID.Type,'yinyang')
        if FPOS.yyNumSlices==1
            FPOS.size(1,2)  = FPOS.size(1,2) *1.0; 	%same overall height
            FPOS.size       = FPOS.size *1.0;    	%same overall size
        elseif FPOS.yyNumSlices==2
            FPOS.size(1,2)  = FPOS.size(1,2) *1.8; 	%larger overall height
            FPOS.size       = FPOS.size *0.9;    	%decrease overall size
        elseif FPOS.yyNumSlices==3
            FPOS.size(1,2)  = FPOS.size(1,2) *2.5; 	%larger overall height
            FPOS.size       = FPOS.size *0.8;    	%decrease overall size
        end
        
    else
        error('no geometry found! check here.')
    end
    
    %special 3-D
    if FPOS.subplotLayout(1,1)==3 && FPOS.subplotLayout(1,2)==2; FPOS.size = [870 850]; end  %[3 2] 3d_evolution
end


%% apply figure position
FPOS.position = [FPOS.x FPOS.y FPOS.size(1,1) FPOS.size(1,2)];
set(gcf,'Position',FPOS.position);

end
