
%%                                                   PLOT CUSTOM GRAPH 3.61

%                                                Fabio Crameri, 30.01.2017

%% NOTES
% only implemented for 2-D geometry, yet.
% absolute values not perfect yet, as it might inhibit normal negative values....

function [PLOT,SAVE] = f_plotCustomGraph(FIELD,GRID,SWITCH,SETUP,PLOT,FILE,STYLE,SAVE)
%% COUNT CALLS
if ~isfield(SAVE,'numGraphsPlotted'); SAVE.numGraphsPlotted = 1; else; SAVE.numGraphsPlotted = SAVE.numGraphsPlotted+1; end

%% DEFAULTS
plotYmean                   = false;
absoluteValues              = false;
plotAcceleration            = false;
plotSinkingOverTrenchVel    = false;
graphLineStyle              = '-';          %'o' or '-'

%% INPUT
if strcmp(PLOT.CustomGraphName(SAVE.numGraphsPlotted),'custom')
    dataNameX                   = {'Slab-Tip Depth'};       %e.g., 'Time', see STAGplot for available fields
    % 'Time', 'Slab Tip Position Z'
    dataNameY                   = {'Upper-Plate Tilt'};      %see STAGplot for available fields
    % 'Upper-Plate Velocity' 'Lower-Plate Velocity' 'Convergence Velocity'
    % 'Max. Plate Stress', 'Trench Velocity', 'Trench Position', 'Upper-Plate Dip'
    numMin                      = 1;
    numMax                      = 120;
    indicateCurrentTime         = logical(1);
    VARIA.fieldName             = 'Custom Graph';           %title
    interpolateRoughGridData    = logical(1);               %applied only for some parameters
    data2check                  = 'Tectonics';              %data file to use

elseif strcmp(PLOT.CustomGraphName(SAVE.numGraphsPlotted),'SlabSinking vs. TrenchRetreat')
    dataNameX                   = {'Trench Velocity'}; 	%e.g., 'Time', see STAGplot for available fields
    dataNameY                   = {'Slab Sinking Velocity'};      %see STAGplot for available fields
    plotAcceleration            = logical(0);
    numMin                      = 1;
    numMax                      = 20;
    indicateCurrentTime         = logical(0);
    VARIA.fieldName             = 'Trench Dynamics';   	%title
    absoluteValues              = logical(0);               %plots only absolute values
    interpolateRoughGridData    = logical(0);               %applied only for some parameters
    data2check                  = 'Tectonics';              %data file to use
    graphYAxisMin              	=   -10.0;
    graphYAxisMax             	=   10.0;
%     graphXAxisMin           	=   0;
%     graphXAxisMax            	=   40;
    
elseif strcmp(PLOT.CustomGraphName(SAVE.numGraphsPlotted),'PlateVelocities vs. Time')
    dataNameX                   = {'Time'}; 	%e.g., 'Time', see STAGplot for available fields
    dataNameY                   = {'Trench Velocity', 'Theoretic Trench Velocity', 'Lower-Plate Velocity', 'Convergence Velocity', 'Slab Sinking Velocity'};      %see STAGplot for available fields
%     dataNameY                   = {'Trench Velocity'};      %see STAGplot for available fields
    plotAcceleration            = logical(0);
    numMin                      = 1;
    numMax                      = 999;
    indicateCurrentTime         = logical(0);
    VARIA.fieldName             = 'Plate Velocities';   	%title
    absoluteValues              = logical(0);               %plots only absolute values
    interpolateRoughGridData    = logical(0);               %applied only for some parameters
    data2check                  = 'Tectonics';              %data file to use
    graphYAxisMin              	=   -10.0;
    graphYAxisMax             	=   10.0;
    graphXAxisMin           	=   0;
    graphXAxisMax            	=   55;

elseif strcmp(PLOT.CustomGraphName(SAVE.numGraphsPlotted),'UPtilt vs. SlabDepth')
    dataNameX                   = {'Slab-Tip Depth'};       %e.g., 'Time', see STAGplot for available fields
    dataNameY                   = {'Upper-Plate Tilt'};      %see STAGplot for available fields
    numMin                      = 1;
    numMax                      = 120;
    indicateCurrentTime         = logical(1);
    VARIA.fieldName             = 'Slab-UP Interaction';   	%title
    interpolateRoughGridData    = logical(1);               %applied only for some parameters
    data2check                  = 'Tectonics';              %data file to use
    graphXAxisMin            	=   300;
    graphXAxisMax            	=   1000;
    graphYAxisMin           	=   0;
    graphYAxisMax            	=   0.1;
    plotYmean                   = logical(1);
    
elseif strcmp(PLOT.CustomGraphName(SAVE.numGraphsPlotted),'SlabAngle vs. Time')
    dataNameX                   = {'Time'}; 	%e.g., 'Time', see STAGplot for available fields
    dataNameY                   = {'Slab Angle'};      %see STAGplot for available fields
    numMin                      = 1;
    numMax                      = 20;
    indicateCurrentTime         = logical(1);
    VARIA.fieldName             = 'Slab-Dip Angle';   	%title
    interpolateRoughGridData    = logical(0);               %applied only for some parameters
    data2check                  = 'Tectonics';              %data file to use
    graphYAxisMin           	=   0;
    graphYAxisMax            	=   90;
    
elseif strcmp(PLOT.CustomGraphName(SAVE.numGraphsPlotted),'ViscosityContrast vs. Time')
    dataNameX                   = {'Time'}; 	%e.g., 'Time', see STAGplot for available fields
    dataNameY                   = {'Slab-Mantle Visc.Contrast'};      %see STAGplot for available fields
    numMin                      = 1;
    numMax                      = 20;
    indicateCurrentTime         = logical(1);
    VARIA.fieldName             = 'Slab-Mantle Visc.Contrast';   	%title
    interpolateRoughGridData    = logical(0);               %applied only for some parameters
    data2check                  = 'Tectonics';              %data file to use
    graphXAxisMin            	=   0;
    graphXAxisMax            	=   10;
    graphYAxisMin           	=   0;
    graphYAxisMax            	=   200;
   
elseif strcmp(PLOT.CustomGraphName(SAVE.numGraphsPlotted),'Sinking/Trench Vel. vs. Time')
    dataNameX                   = {'Time'}; 	%e.g., 'Time', see STAGplot for available fields
    dataNameY                   = {'Slab Sinking Velocity','Trench Velocity'};      %see STAGplot for available fields
    plotSinkingOverTrenchVel    = true;
    numMin                      = 1;
    numMax                      = 20;
    indicateCurrentTime         = logical(1);
    VARIA.fieldName             = 'Sinking/Trench Vel.';   	%title
    interpolateRoughGridData    = logical(0);               %applied only for some parameters
    data2check                  = 'Tectonics';              %data file to use
    graphXAxisMin            	=   0;
    graphXAxisMax            	=   10;
    graphYAxisMin           	=   0;
    graphYAxisMax            	=   3;
    
elseif strcmp(PLOT.CustomGraphName(SAVE.numGraphsPlotted),'ViscContrast vs. Sinking/Trench Vel.')
    dataNameX                   = {'Slab Sinking Velocity','Trench Velocity'};       %e.g., 'Time', see STAGplot for available fields
    plotSinkingOverTrenchVel    = true;
    dataNameY                   = {'Slab-Mantle Visc.Contrast'};       %see STAGplot for available fields
    numMin                      = 1;
    numMax                      = 20;
    indicateCurrentTime         = logical(1);
    VARIA.fieldName             = 'Slab-Mantle Visc.Contrast';   	%title
    interpolateRoughGridData    = logical(0);               %applied only for some parameters
    data2check                  = 'Tectonics';              %data file to use
    graphXAxisMin            	=   -3;
    graphXAxisMax            	=   5;
    graphYAxisMin           	=   0;
    graphYAxisMax            	=   200;
    graphLineStyle              = 'o';          %'o' or '-'
    
elseif strcmp(PLOT.CustomGraphName(SAVE.numGraphsPlotted),'SlabAngle vs. Sinking/Trench Vel.')
    dataNameX                   = {'Slab Sinking Velocity','Trench Velocity'};       %e.g., 'Time', see STAGplot for available fields
    plotSinkingOverTrenchVel    = true;
    dataNameY                   = {'Slab Angle'};       %see STAGplot for available fields
    numMin                      = 1;
    numMax                      = 20;
    indicateCurrentTime         = logical(1);
    VARIA.fieldName             = 'Slab-Dip Angle';   	%title
    interpolateRoughGridData    = logical(0);               %applied only for some parameters
    data2check                  = 'Tectonics';              %data file to use
    graphXAxisMin            	=   -3;
    graphXAxisMax            	=   5;
    graphYAxisMin           	=   0;
    graphYAxisMax            	=   90;
    graphLineStyle              = 'o';          %'o' or '-'

elseif strcmp(PLOT.CustomGraphName(SAVE.numGraphsPlotted),'TrenchDepth vs. Time')
    dataNameX                   = {'Time'}; 	%e.g., 'Time', see STAGplot for available fields
    dataNameY                   = {'Trench Depth'};      %see STAGplot for available fields
    numMin                      = 1;
    numMax                      = 20;
    indicateCurrentTime         = logical(1);
    VARIA.fieldName             = 'Trench Depth';   	%title
    interpolateRoughGridData    = logical(0);               %applied only for some parameters
    data2check                  = 'Tectonics';              %data file to use
    graphXAxisMin            	=   0;
    graphXAxisMax            	=   10;
    graphYAxisMin           	=   0;
    graphYAxisMax            	=   200;
    
elseif strcmp(PLOT.CustomGraphName(SAVE.numGraphsPlotted),'TrenchDepth vs. Sinking/Trench Vel.')
    dataNameX                   = {'Slab Sinking Velocity','Trench Velocity'};       %e.g., 'Time', see STAGplot for available fields
    plotSinkingOverTrenchVel    = true;
    dataNameY                   = {'Trench Depth'};       %see STAGplot for available fields
    numMin                      = 1;
    numMax                      = 20;
    indicateCurrentTime         = logical(1);
    VARIA.fieldName             = 'Trench Depth';   	%title
    interpolateRoughGridData    = logical(0);               %applied only for some parameters
    data2check                  = 'Tectonics';              %data file to use
    graphXAxisMin            	=   -3;
    graphXAxisMax            	=   5;
    graphYAxisMin           	=   1;
    graphYAxisMax            	=   -10;
    graphLineStyle              = 'o';          %'o' or '-'
    
elseif strcmp(PLOT.CustomGraphName(SAVE.numGraphsPlotted),'MaxPlateStress vs. Time')
    dataNameX                   = {'Time'}; 	%e.g., 'Time', see STAGplot for available fields
    dataNameY                   = {'Max. Plate Stress'};      %see STAGplot for available fields
    numMin                      = 0;
    numMax                      = 86;
    indicateCurrentTime         = logical(1);
    VARIA.fieldName             = 'Max. Plate Stress';   	%title
    interpolateRoughGridData    = logical(0);               %applied only for some parameters
    data2check                  = 'Tectonics';              %data file to use
%     graphXAxisMin            	=   0;
%     graphXAxisMax            	=   10;
%     graphYAxisMin           	=   0;
%     graphYAxisMax            	=   200;

elseif strcmp(PLOT.CustomGraphName(SAVE.numGraphsPlotted),'MaxYieldDepth vs. Time')
    dataNameX                   = {'Time'}; 	%e.g., 'Time', see STAGplot for available fields
    dataNameY                   = {'Max. Yield Depth Fraction'};      %see STAGplot for available fields
    dataNameY                   = {'Max. Yield Depth'};      %see STAGplot for available fields
    numMin                      = 1;
    numMax                      = 52;
    indicateCurrentTime         = logical(1);
    VARIA.fieldName             = 'Max. Yield Depth';   	%title
    interpolateRoughGridData    = logical(0);               %applied only for some parameters
    data2check                  = 'Tectonics';              %data file to use
%     graphXAxisMin            	=   0;
%     graphXAxisMax            	=   10;
%     graphYAxisMin           	=   0;
%     graphYAxisMax            	=   200;
end

%% SWITCHES CHECK
plotLegend = true;
if PLOT.loopCase>1
    plotLegend = false;
end
if plotAcceleration && absoluteValues
    absoluteValues = false;
end
  
%% LOOK FOR DATA FILE
orgDir = pwd;
fileNotFound = false;
if ~exist([FILE.directory,'+data'],'dir')
    fileNotFound = true;
else
    cd([FILE.directory,'+data'])
    filetofind      = [FILE.name,'_',data2check,num2str(numMax),'.mat'];
    % IF FILE NOT FOUND CHECK FOR LATEST FILE
    if ~exist(filetofind,'file')
        % check for last output file number
        for io=numMin:numMax
            filetofind	= [FILE.name,'_',data2check,num2str(io),'.mat'];
            if ispc
                filetofind       = strrep(filetofind,'/','\');
            end
            if ~exist(filetofind,'file') %&& io~=0 %sometimes 0 has no data
                numMax=io-1; %update max number
                break  %exit loop
            end
        end
    end
    % ERROR MESSAGE IF NO FILE AT ALL IS NOT FOUND
    if numMax==-1 || numMax<numMin
        fileNotFound = true;
        warning(['file not found - check file directory: ',FILE.directory,'+data/',filetofind])
    end
    cd(orgDir);
end
arraySize = abs(numMax-numMin)+1;


if fileNotFound || strcmp(GRID.Dim,'3-D')
    %% EMPTY PLOT IF NO FILE FOUND
    [PLOT,SAVE] = f_emptyPlot(SWITCH,PLOT,GRID,FIELD,STYLE,SAVE);
    
else
    %% READ DATA
    % Read graph data produced by StagLab
    Time2check  = zeros(arraySize,1);
    xName       = cell(1,size(dataNameX,2)); xName(:) = {'NaN'};
    xGroupName 	= xName;
    xDim        = xName;
    xData       = zeros(arraySize,size(dataNameX,2));
    yName       = cell(1,size(dataNameY,2)); yName(:) = {'NaN'};
    yGroupName  = yName;
    yDim        = yName;
    yData       = zeros(arraySize,size(dataNameY,2));
    itimestep   = 0;
    for number=numMin:numMax %loop time steps
        itimestep = itimestep+1;
        % TECTONIC DATA:
        % [name, dim, data]
        dummy = [FILE.directory,'+data/',FILE.name,'_',data2check,num2str(number),'.mat'];
        if ispc; dummy = strrep(dummy,'/','\'); end
        load(dummy);
        
        %always read time
        Time2check(itimestep,1)  	= saveData{1,4}.*PLOT.timeConvert;
        
        %read necessary data
        try
            for idata=1:size(dataNameX,2) %read necessary data rows
                if itimestep==1 %just once
                    conversionFactorX   	= 1;
                    xName(1,idata)          = saveData(strcmp(saveData(:,1),dataNameX(1,idata)),1);
                    xGroupName(1,idata)     = saveData(strcmp(saveData(:,1),dataNameX(1,idata)),2);
                    if strcmp(xName(1,idata),'Time')
                        conversionFactorX 	= PLOT.timeConvert;      %dimensionalise time
                        xDim(1,idata)      	= {PLOT.time2plotDim};
                    else
                        xDim(1,idata)    	= saveData(strcmp(saveData(:,1),dataNameX(1,idata)),3);
                    end
                end
                dummy = saveData{strcmp(saveData(:,1),dataNameX(1,idata)),4} *conversionFactorX;
                xData(itimestep,idata)      = dummy(1,1);
            end
        catch errme
            warning(['The data for "',dataNameX{1,idata},'" could not be found. You might need to recalculate and overwrite your data files!'])
            %% EMPTY PLOT IF NO FILE FOUND
            [PLOT,SAVE] = f_emptyPlot(SWITCH,PLOT,GRID,FIELD,STYLE,SAVE);
            
            return
        end
        
        %read necessary data
        try
            for idata=1:size(dataNameY,2) %read necessary data rows
                if itimestep==1 %just once
                    conversionFactorY    	= 1;
                    yName(1,idata)          = saveData(strcmp(saveData(:,1),dataNameY(1,idata)),1);
                    yGroupName(1,idata)     = saveData(strcmp(saveData(:,1),dataNameY(1,idata)),2);
                    if strcmp(yName(1,idata),'Time')
                        conversionFactorY 	= PLOT.timeConvert;     %dimensionalise time
                        yDim(1,idata)      	= {PLOT.time2plotDim};
                    else
                        yDim(1,idata)     	= saveData(strcmp(saveData(:,1),dataNameY(1,idata)),3);
                    end
                end
                dummy = saveData{strcmp(saveData(:,1),dataNameY(1,idata)),4} *conversionFactorY;
                yData(itimestep,idata)   	= dummy(1,1);  %only the data of one tracking point
            end
        catch errme
            warning(['The data for "',dataNameY{1,idata},'" could not be found. You might need to recalculate and overwrite your data files!'])
            %% EMPTY PLOT IF NO FILE FOUND
            [PLOT,SAVE] = f_emptyPlot(SWITCH,PLOT,GRID,FIELD,STYLE,SAVE);
            
            return
        end
    end
    
    %% DATA IMPROVEMENT
    %intelligently replace NaN's
    
    %smooth discrete grid data
    if interpolateRoughGridData
        if strcmp(dataNameX(1,1),'Slab-Tip Depth') || strcmp(dataNameX(1,1),'Slab-Tip Horiz. Position')
            %check if x-and y-data are monotonically increasing (not strictly, i.e., can be stagnant)
            if sum(all(diff(xData)>=0))<=0; xMonotonic = false; else; xMonotonic = true; end
            if sum(all(diff(yData)>=0))<=0; yMonotonic = false; else; yMonotonic = true; end
            if ~xMonotonic && ~yMonotonic %if non-monotonic on both axes
                %spline fitting over the whole graph cannot be applied!
                %do it step-wise (from point to point) instead.
                if ~all(diff(xData)) %if repeating numbers on y-axis
                    xdummy               	= zeros(size(xData));
                    xdummy(diff(xData)~=0) 	= xData(diff(xData)~=0);
                    dummy                   = xdummy;
                    xdummy(dummy==0)       	= [];
                    xdummyFull             	= dummy;
                    ydummyFull            	= 1:size(xData,1);  ydummyFull = ydummyFull';
                    ydummy                  = ydummyFull;
                    ydummy(dummy==0)        = [];
                    % average values at repeated entries:
                    for idata=1:size(xdummyFull,1)
                        if dummy(idata,1)==0
                            %get group average
                            groupLeftIdx = idata;
                            groupRightIdx = idata; averageValue = 0;
                            ilocal = 1; groupValues = 0;
                            while groupRightIdx<size(yData,1) && dummy(groupRightIdx,1)==0
                                groupValues(ilocal,1) = yData(groupRightIdx,1);
                                ilocal = ilocal+1;
                                groupRightIdx = groupRightIdx+1;
                            end
                            if groupValues~=0
                                yData(groupLeftIdx:groupRightIdx,1) = mean(groupValues);
                            end
                        end
                    end
                end
                if ~all(diff(yData)) %if repeating numbers on y-axis
                    xdummy               	= zeros(size(yData));
                    xdummy(diff(yData)~=0) 	= yData(diff(yData)~=0);
                    dummy                   = xdummy;
                    xdummy(dummy==0)       	= [];
                    xdummyFull             	= dummy;
                    ydummyFull            	= 1:size(yData,1);  ydummyFull = ydummyFull';
                    ydummy                  = ydummyFull;
                    ydummy(dummy==0)        = [];
                    % average values at repeated entries:
                    for idata=1:size(xdummyFull,1)
                        if dummy(idata,1)==0
                            %get group average
                            groupLeftIdx = idata;
                            groupRightIdx = idata; averageValue = 0;
                            ilocal = 1; groupValues = 0;
                            while groupRightIdx<size(xData,1) && dummy(groupRightIdx,1)==0
                                groupValues(ilocal,1) = xData(groupRightIdx,1);
                                ilocal = ilocal+1;
                                groupRightIdx = groupRightIdx+1;
                            end
                            if groupValues~=0
                                xData(groupLeftIdx:groupRightIdx,1) = mean(groupValues);
                            end
                        end
                    end
                end
                
            else
                if ~all(diff(xData)) %if repeating numbers on x-axis
                    xdummy               	= zeros(size(xData));
                    xdummy(diff(xData)~=0) 	= xData(diff(xData)~=0);
                    dummy                   = xdummy;
                    xdummy(dummy==0)       	= [];
                    xdummyFull             	= dummy;
                    xdummyFull(dummy==0)  	= NaN;
                    ydummyFull            	= 1:size(xData,1);  ydummyFull = ydummyFull';
                    ydummy                  = ydummyFull;
                    ydummy(dummy==0)        = [];
                    % add spline to the available graph points:
                    smoothingParam      	= 0.5;         %2e-7 Smoothing of fitted line: 0: total smooth (i.e., linear), 1: no smoothing
                    fo                      = fit(ydummy,xdummy,'smoothingspline','smoothingparam',smoothingParam);
                    for idata=1:size(xdummyFull,1)
                        if isnan(xdummyFull(idata,1))
                            xdummyFull(idata,1) = fo(ydummyFull(idata,1));
                        end
                    end
                    xData                   = xdummyFull;
                end
                if ~all(diff(yData)) %if repeating numbers on y-axis
                    xdummy               	= zeros(size(yData));
                    xdummy(diff(yData)~=0) 	= yData(diff(yData)~=0);
                    dummy                   = xdummy;
                    xdummy(dummy==0)       	= [];
                    xdummyFull             	= dummy;
                    xdummyFull(dummy==0)  	= NaN;
                    ydummyFull            	= 1:size(yData,1);  ydummyFull = ydummyFull';
                    ydummy                  = ydummyFull;
                    ydummy(dummy==0)        = [];
                    % add spline to the available graph points:
                    smoothingParam      	= 0.5;         %2e-7 Smoothing of fitted line: 0: total smooth (i.e., linear), 1: no smoothing
                    fo                      = fit(ydummy,xdummy,'smoothingspline','smoothingparam',smoothingParam);
                    for idata=1:size(xdummyFull,1)
                        if isnan(xdummyFull(idata,1))
                            xdummyFull(idata,1) = fo(ydummyFull(idata,1));
                        end
                    end
                    yData                   = xdummyFull;
                end
            end
        end
    end
    
    %% ERROR CHECKS
%     if strcmp(GRID.Type,'cylindrical')
%         % RE-FLIP DEPTH VECTOR AND ACCOUNT FOR STICKY-AIR LAYER
%         z2d = z2d +SETUP.d_air*GRID.dimFactor;  %set z=0 to real surface
%         z2d = 1*GRID.dimFactor -z2d; % reverse z-axis  (1.)
%     end
    
    %% DATA ALTERATIONS
    if absoluteValues
        yData                           = abs(yData);
    end
    if plotAcceleration
        dv                              = yData(2:end,:) - yData(1:end-1,:);
        dt                              = xData(2:end,:) - xData(1:end-1,:);
        yData                           = dv./dt;
        if ~isempty(yData)
            yData                       = [yData;yData(1,:)*NaN]; %fill empty last row with NaNs
        end
        
        dataNameY                       = strrep(dataNameY,'Velocity','Acceleration');
        yGroupName                      = strrep(yGroupName,'Velocity','Acceleration');
        VARIA.fieldName                 = strrep(VARIA.fieldName,'Velocities','Accelerations');
        yDim(:,:)                    	= {'cm/a^2'};
    end
    if plotSinkingOverTrenchVel
        if strcmp(dataNameX(1,1),'Slab Sinking Velocity')
            xData = xData(:,1)./xData(:,2);
            xDim                            = {'nd'};
            xGroupName                      = {'v_{SlabSinking}/v_{Trench}'};
            xName                           = {'v_{SlabSinking}/v_{Trench}'};
            %VARIA.fieldName                 = 'v_{SlabSinking}/v_{Trench}';
            dataNameX                       = xGroupName;
        elseif strcmp(dataNameY(1,1),'Slab Sinking Velocity')
            yData = yData(:,1)./yData(:,2);
            yDim                            = {'nd'};
            yGroupName                      = {'v_{SlabSinking}/v_{Trench}'};
            yName                           = {'v_{SlabSinking}/v_{Trench}'};
            VARIA.fieldName                 = 'v_{SlabSinking}/v_{Trench}';
            dataNameY                       = yGroupName;
        end
    end
    
    %% DEFINE AXIS SETUP
    multipleXgraphs             = false;
    multipleYgraphs             = false;
    if size(dataNameX,2)==1 && size(dataNameY,2)>1  %single data on x-axis & multiple data on y-axis
        multipleYgraphs             = true;
        numGraphs                   = size(dataNameY,2);
        xDataPlot                   = zeros(size(yData));
        for ii=1:numGraphs; xDataPlot(:,ii) = xData; end %needs to be same size as yData
        yDataPlot                   = yData;
        VARIA.xlabelName            = xName{1,1};
        VARIA.zlabelName            = yGroupName{1,1};
        
    elseif size(dataNameX,2)>1 && size(dataNameY,2)==1  %multiple data on x-axis & single data on y-axis
        multipleXgraphs             = true;
        numGraphs                   = size(dataNameY,2);
        xDataPlot                   = xData;
        yDataPlot                   = zeros(size(xData));
        for ii=1:numGraphs; yDataPlot(:,ii) = yData; end %needs to be same size as xData
        VARIA.xlabelName            = xGroupName{1,1};
        VARIA.zlabelName            = yName{1,1};
        
    elseif size(dataNameX,2)==1 && size(dataNameY,2)==1  %single data on both axes
        numGraphs                   = 1;
        xDataPlot                   = xData;
        yDataPlot                   = yData;
        VARIA.xlabelName            = xName{1,1};
        VARIA.zlabelName            = yName{1,1};
        
    else
        error('Graph plot cannot have multiple data sets on both axes!')
    end
    VARIA.xlabelDim             = xDim{1,1};
    VARIA.zlabelDim             = yDim{1,1};

    
    %% GRAPH DIAGNOSTICS
    if plotYmean
        FitRangeX       = [ 400, 600; 700, 1000];        %x-range(s) for fit
        yMean = zeros(size(FitRangeX,1),1);
        for i=1:size(FitRangeX,1)
            if logical(1) %include all points temporally after the lower limit index
                [~,idx3]   	= min( abs(xDataPlot(xDataPlot(:,1)<=FitRangeX(i,2)) -FitRangeX(i,1)) ); %index of lower bound
                dummy     	= yDataPlot(idx3:end,1); %values to take mean of
                dummyX      = xDataPlot(idx3:end,1);
                dummy(dummyX(:,1)>FitRangeX(i,2)) = NaN;
                    
            else %points only within the limits
                dummy     	= yDataPlot(xDataPlot(:,1)>=FitRangeX(i,1) & xDataPlot(:,1)<=FitRangeX(i,2)); %values to take mean of
            end
            yMax(i,1)       = max( dummy(~isnan(dummy)) );
            yMin(i,1)       = min( dummy(~isnan(dummy)) );
            yMean(i,1)      = mean( dummy(~isnan(dummy)) );
            yStdDev(i,1)	= std( dummy(~isnan(dummy)) );
        end
    end
    
    %% SETUP FIGURE
    figure(1)
    
    %% COUNT SUBPLOTS
    PLOT.nrSubplot = PLOT.nrSubplot+1;
    
    %% SETUP SUBPLOTS
    SPOS.task   = 'createSubplot';
    [SP,SAVE] = f_subplotPosition(SPOS,PLOT,SWITCH,SAVE);
    
    %% CURRENT AXIS
    AXcurrent = gca; %save current axes handle
    
    %% PLOTTING GRAPH
    hold on
    for iline=1:numGraphs
        if multipleXgraphs
            legendString(iline,1)	= dataNameX(1,iline);
        elseif multipleYgraphs
            legendString(iline,1)	= dataNameY(1,iline);
        else
            legendString(iline,1)	= dataNameY(1,iline);
        end
        
        GRAPH.hLine(iline,1) = plot(xDataPlot(:,iline),yDataPlot(:,iline),graphLineStyle,...
            'MarkerFaceColor',STYLE.keyLineColor,'MarkerEdgeColor','none','LineWidth',STYLE.keyLineWidth);
        
        if size(xDataPlot,2)==1 && size(yDataPlot,2)==1
            set(GRAPH.hLine(iline,1),'Color',STYLE.keyLineColor);
        end
        hold on
        
        %MARKER FOR CURRENT TIME POSITION
        if indicateCurrentTime
            currentLineColor    = get(GRAPH.hLine(iline,1),'Color');
            dummy = round(Time2check(:,1),4)==round(PLOT.time2plot,4);
            xCurrentPoint       = xDataPlot(dummy,iline);
            yCurrentPoint       = yDataPlot(dummy,iline);
            if isempty(xCurrentPoint) && strcmp(dataNameX(1,1),'Time') %if time point is outside data range
                xCurrentPoint   = PLOT.time2plot;
                yCurrentPoint   = yDataPlot(end,iline);
            elseif isempty(xCurrentPoint) && strcmp(dataNameY(1,1),'Time') %if time point is outside data range
                xCurrentPoint   = yDataPlot(end,iline);
                yCurrentPoint   = PLOT.time2plot;
            else
%                 xCurrentPoint   = NaN; %no time graph
%                 yCurrentPoint   = NaN;
            end

            plot(xCurrentPoint,yCurrentPoint,'o',...
                'MarkerEdgeColor','none','MarkerFaceColor',currentLineColor);
        end
        
        %LINE FITTINGS
        if plotYmean
            for i=1:size(yMean,1)
                hold on
                plot(FitRangeX(i,:),[yMean(i,1),yMean(i,1)],...
                    'LineWidth',STYLE.keyLineWidth,'Color',[0.5 0.5 0.5]);
                plot(FitRangeX(i,:),[yMean(i,1),yMean(i,1)],...
                    '--','LineWidth',STYLE.keyLineWidth,'Color',[0.8 0.2 0.2]);
            end
        end
    end
    
    %     xpoints = x2d_plate;
    %     upper = vh_plate;
    %     if ~strcmp(TOPO.areaFill,'none')
    %         if strcmp(TOPO.areaFill,'down')
    %             color = STYLE.keyLineColor;
    %             lower = zeros(size(upper))+(min(upper)-1/10*(max(upper)-min(upper)));
    %             if TOPO.indicateComponents && PLOT.topoLOWval<lower(1,1);
    %                 lower = zeros(size(upper))+PLOT.topoLOWval;
    %             end
    %             if SWITCH.Colorbar(1,2); lower = zeros(size(upper))+FIELD.cColorbarMIN; end %constant colorbar
    %             if SWITCH.plotDifference && strcmp(TOPO.difference,'diff'); lower = lower*0; end %in relation to 0 topography
    %
    %         elseif strcmp(TOPO.areaFill,'updown')
    %             color = STYLE.keyLineColor;
    %             lower = zeros(size(upper));
    %         else
    %             error(['TOPO.areaFill mode ',TOPO.areaFill,'not recognised!'])
    %         end
    %     end
    
    if plotLegend && ~isempty(legendString) && (size(legendString,1)>1 || ~strcmp(legendString{1,1},yGroupName{1,1}))
        plotLegend = true;
    end
    if plotLegend
        legend(GRAPH.hLine,legendString{:},'Location','SouthEast'); %,'Location','NorthEast'
    end
    hold off
    
    VARIA.task    = 'create annotation strings';
    [PLOT,VARIA] = f_varia(VARIA,FIELD,GRID,SWITCH,PLOT,STYLE,SAVE);
    
    VARIA.task    = 'make title';
    [PLOT,VARIA] = f_varia(VARIA,FIELD,GRID,SWITCH,PLOT,STYLE,SAVE);
    
    xlabel(PLOT.xlabel)
    ylabel(PLOT.ylabel)
    
    axis tight
    
    if SWITCH.Colorbar(1,2)
        if ~exist('graphYAxisMin','var'); graphYAxisMin = FIELD.cColorbarMIN; end
        if ~exist('graphYAxisMax','var'); graphYAxisMax = FIELD.cColorbarMAX; end
        ylim([graphYAxisMin graphYAxisMax]);
        if exist('graphXAxisMin','var') && exist('graphXAxisMax','var')
            xlim([graphXAxisMin graphXAxisMax]);
        end
    end
    if SWITCH.setAxisLimit
        if size(SWITCH.axisLimit,1)>1  %more than one axis-zoom value
            xlim(SWITCH.axisLimit(PLOT.loopCase,1:2));
        else
            xlim(SWITCH.axisLimit(1,1:2));
        end
    end
    %set(AXcurrent,'YGrid','on')
    grid on
    box on
    %set tickmarks out- or inside
    set(gca,'TickDir',SWITCH.tickDir)
    
    if SWITCH.texting
        try
            text(min(xlim),max(ylim),['mean: ',num2str(yMean(1,1),3),'(',num2str(yStdDev(1,1),3),')'],'HorizontalAlignment','left','VerticalAlignment','bottom','FontSize',8)
            text(max(xlim),max(ylim),['mean: ',num2str(yMean(2,1),3),'(',num2str(yStdDev(2,1),3),')'],'HorizontalAlignment','right','VerticalAlignment','bottom','FontSize',8)
            disp(['   mean: ',num2str(yMean(1,1)),' / std. deviation: ',num2str(yStdDev(1,1))])
            disp(['   mean: ',num2str(yMean(2,1)),' / std. deviation: ',num2str(yStdDev(2,1))])
            %make data array
            if ~isfield(SAVE,'graphData')
                SAVE.graphData  = []; 
                dummy   	= 2;
            else
                dummy     	= size(SAVE.graphData,1)+2;
            end
            if dummy>11
                dummy   	= dummy-10;
                suite       = 3;
            elseif dummy>6
                dummy     	= dummy-5;
                suite       = 2;
            else
                suite       = 1;
            end
            angle           = dummy*10;
            SAVE.graphData  = [SAVE.graphData; suite, angle, yMean(1,1), yStdDev(1,1), yMean(2,1), yStdDev(2,1)];
            
            if size(SAVE.graphData,1)==15 %last one
                SAVE.Directory              = [FILE.stemImages,FILE.name,'/'];
                SAVE.DataName               = '+graphData';
                SAVE.data                   = SAVE.graphData;
                SAVE.dat                    = logical(0);
                SAVE.txt                    = logical(0);
                SAVE.mat                    = logical(1);
                SAVE.write2existing         = logical(0);
                SAVE.overwrite              = logical(0);     %this is a global variable!
                SAVE.Pause                  = logical(0);
                
                [SAVE.overwriteAll] = f_saveData( SAVE );
            end
            
        catch 
            %nothing to do
        end
    end
    
    %% COLORBAR
    colorbar;   %define dummy colorbar
    PLOT.cb = NaN; 	%this is a flag if no colorbar is used
    
    %% SIMPLIFY FIGURE
    if SWITCH.simplify
        %SET AXES ASPECT RATIO ----
        XaxisAR = GRID.aspectRatio(1);
        YaxisAR = 1;
        ZaxisAR = 1;
        set(gca,'PlotBoxAspectRatio',[XaxisAR YaxisAR ZaxisAR])
        %--------------------------
        
        %GATHER INFORMATION ABOUT SUBPLOT LAYOUT
        PLOT.spcurrent          = SP.current;
        PLOT.sp_chax            = AXcurrent;
        if exist('haxZ','var'); PLOT.sp_chaxz = haxZ; else; PLOT.sp_chaxz = NaN; end
        PLOT.sp_ccb             = PLOT.cb;   %colorbar handle
        PLOT.title              = PLOT.titleStringCurrent;  	%title string
        
        [PLOT] = f_designLayout(SWITCH,PLOT,GRID,FIELD);
    end
    
    %.........
    drawnow  %actually only needed if topo or other graph plot is included (axis change otherwise)
    %.........
    
    if isfield(PLOT,'hax'); nr_hax = size(PLOT.hax,1)+1; else; nr_hax = 1; end
    
    %% FUNCTION OUTPUT
    PLOT.hax(nr_hax,1)  = AXcurrent;
    
    %indicate axis handle as graph subplot
    SAVE.graphPlotHandles = [SAVE.graphPlotHandles; AXcurrent]; %indicate axis handle as graph subplot
    SAVE.PlotHandles = [SAVE.PlotHandles; AXcurrent];
    
end




