
%%                                                          PARAMETER FILE
%                                                          for STAGtimedat

clear; clf;
if ~exist('f_defaultsTimedat','file'); f_INSTALL; end
[IN,PLOT,SWITCH,STYLE,SAVE] = f_defaultsTimedat; %get default variables

%% INPUT FILE(S)
IN.name                         =   { 'test'  'test'	};   	% filename
IN.parameter                    =   [   11         ];
IN.folder                       =   {'/work/stagyy/'};

%% SAVING
SAVE.Plot                       =   logical(0);                 % saves plot directly to directory   
    SAVE.jpg                    =   logical(0); 
    SAVE.eps                    =   logical(0); 
    SAVE.pdf                    =   logical(0); 
    SAVE.png                    =   logical(1);
        SAVE.pngResolution      =   '-m4.0';

%% DIMENSIONALISATION
SWITCH.dim                      =   logical(0);
    SWITCH.modelSetup           =   'standard';             	%see f_dimParameter

%% STYLING
SWITCH.styleBackground          =   logical(1);
SWITCH.stylePlots               =   logical(1);
SWITCH.styleLegend              =   logical(1);
SWITCH.simplify                 =   logical(1);
%colours
STYLE.colorMode                 =   'light';                    %'light' or 'dark' figure background

%% APP PERFORMANCE
IN.checkFileSize                =   logical(0);                 %checks for line number automatically (in case of a problem with data format)

%% PLOT ADDITIONS & LABELLING
SWITCH.parameterRange           =   logical(0);                 %plotting mean, min & max

%% ANNOTATION
SWITCH.annotation               =   logical(1);
    STYLE.annotationLocation    =   'botLeft';                  %'topOutTop','topOutCorner','topLeft','botLeft','topRight','botRight'
    PLOT.annotation             =   {'a' 'b' 'c' 'd' 'e' 'f' 'g' 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' 'p'};  %subplot annotation strings

%% PARAMETER(S) TO PLOT
PLOT.Temperature                =   logical(1);
PLOT.Viscosity                  =   logical(1);
PLOT.Velocity                   =   logical(1);
PLOT.Composition                =   logical(0);

PLOT.Ra_eff                     =   logical(1);   %only 1 value
PLOT.Nu_top                     =   logical(0);   %only 1 value
PLOT.Nu_bot                     =   logical(0);   %only 1 value
PLOT.InternalHeating            =   logical(1);   %only 1 value
PLOT.HeatfluxTop                =   logical(0);   %only 1 value
PLOT.HeatfluxBot                =   logical(0);   %only 1 value
PLOT.EruptionRate               =   logical(0);   %only 1 value
PLOT.EruptHeatFlux              =   logical(0);   %only 1 value
PLOT.Erupta                     =   logical(0);   %only 1 value
PLOT.Entrainment                =   logical(0);   %only 1 value
PLOT.Cmass_error                =   logical(0);   %only 1 value
PLOT.Timesteps                  =   logical(0);   %only 1 value
PLOT.Performance                =   logical(1);   %only 1 value


% //////////////////////////////////////
%           run main routine
[SAVE] = STAGtimedat(IN,PLOT,SWITCH,STYLE,SAVE);
% //////////////////////////////////////











